﻿#region PowerShell

get-verb
get-command
get-help Get-Process -online
get-alias
get-process | Get-Member
(Get-Process).Name
Get-Process | Select-Object Name, ID, path
Get-LocalUser | Get-Member
Get-Process | Select-Object Name, ID, path | Where-Object {$_.ID -lt '1000'} 
(Get-Process | Select-Object Name, ID, path | Where-Object {$_.ID -lt '1000'}).count 
Get-Process | gm | Where-Object {$_.Membertype -match "Method"}
Start-Process calc
(Get-Process calculator*).kill
Get-CimClass *
Get-CimInstance -Namespace root\securitycenter2 -ClassName antispywareproduct
Get-WmiObject -Class Win32_BIOS
Get-CimInstance -class Win32_BIOS
Function Do-Stuff {Get-Date; Get-Process ; Get-Service ; Get-Date }
Do-Stuff
Get-ExecutionPolicy
Set-ExecutionPolicy -ExecutionPolicy Unrestricted -Scope CurrentUser
Remove-Item does_not_exist.txt -ErrorAction SilentlyContinue
new-item -type file it_exists.txt
remove-item .\it_exists.txt -Verbose
$profile
$PSHOME
$profile | gm -type NoteProperty
test-path -path $profile.CurrentUserCurrentHost
New-Item -ItemType file -path $profile -Force
ise $profile
Get-PSSessionConfiguration
Get-Item WSMan:\localhost\Client\TrustedHosts
set-item WSMan:\localhost\Client\TrustedHosts -value "IP" -Concatenate

#endregion PowerShell


#region Registry

# Get-ChildItem reads sub-keys. \Run doesn't have sub-keys, don't use Get-ChildItem
Get-ChildItem HKLM:\SOFTWARE\Microsoft\Windows\CurrentVersion\Run

# Get-Item reads key values
Get-Item HKLM:\SOFTWARE\Microsoft\Windows\CurrentVersion\Run

# New-Item creates a new sub key associated within a hive
New-Item "HKLM:\Software\Microsoft\Office\14.0\Security\Trusted Documents\TrustedRecords" -Force

# Creates a new value in the new Trusted Records Key
New-ItemProperty "HKLM:\Software\Microsoft\Office\14.0\Security\Trusted Documents\TrustedRecords" -Name "%USERPROFILE%Downloads/test-document.doc" -PropertyType Binary

# Creates a new value in the Run Key
New-ItemProperty "HKLM:\Software\Microsoft\Windows\CurrentVersion\Run" -Name Test -PropertyType String -Value C:\Windows\System32\WindowsPowerShell\v1.0\powershell.exe

# Renames/Modifies a value associated with a sub-key
Rename-ItemProperty -Path HKLM:\Software\Microsoft\Windows\CurrentVersion\Run -Name SecurityHealth -NewName Test

# Removes a value associated with a sub-key
Remove-ItemProperty -Path "HKLM:\Software\Microsoft\Office\14.0\Security\Trusted Documents\TrustedRecords" -Name "%USERPROFILE%Downloads/test-document.doc"

# Changes the value of a sub-key
Set-ItemProperty HKLM:\SOFTWARE\Microsoft\Windows\CurrentVersion\Run -Name Test -Value Bacon.exe

# Check to see if our change took effect, remembering that Get-Item reads key values
Get-Item HKLM:\SOFTWARE\Microsoft\Windows\CurrentVersion\Run


#PSDrive creates a temporary or permanent way for PS to navigate the registry, just like you could navigate a filesystem
# Creates a new PS Drive (will create an error)
New-PSDrive -Name HKU -PSProvider Registry -Root HKEY_USER

Get-ChildItem HKU:

# Delete the bad PSDrive
Remove-PSDrive HKU

# Create the PSDrive correctly
New-PSDrive -Name HKU -PSProvider Registry -Root HKEY_USERS

# Create a shortcut to the Run Key
New-PSDrive -Name HKLM-Run -PSProvider Registry -Root HKEY_Local_Machine\SOFTWARE\Microsoft\Windows\CurrentVersion\Run

# Map network shares with New-PSDrive (emulating 'net use' functionality
New-PSDrive -Name "S" -PSProvider FileSystem -Root "\\live.sysinternals.com\Tools"


#Forensically relevant Keys
#Microsoft Edge Internet URL History
HKEY_CLASSES_ROOT\Local Settings\Software\Microsoft\Windws\CurrentVersion\AppContainer\Storage\microsoft.microsoftedge_8wekyb3d8bbwe\Children\001\InternetExplorer\DOMStorage

#USB History
HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Enum\USB


#Registry locations used for persistence
HKLM\Software\Microsoft\Windows\Run
HKU\<SID>\Software\Microsoft\Windows\Run
HKLM\SYSTEM\CurrentControlSet\services
HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\ShellFolders
HKLM\SOFTWARE\Microsoft\WindowsNT\CurrentVersion\Winlogon

#Interesting Registry locations 
HKLM\BCD00000000   #To replace the boot.ini file
HKLM\SAM\SAM       #Use 'psexec -s -i regedit' from cmd.exe to view the SAM
HKU\<SID>\Software\Policies\Microsoft\Windows\System\Scripts    #Group policy Logon/Logoff Scripts are defined here

#Why is Registry baselining important?

#endregion Registry


#region Alternate Data Streams
dir file.txt
type file.txt
ECHO 888-55-4321 > file.txt:secret
DIR file.txt
TYPE file.txt
MORE < file.txt:secret
NOTEPAD file.txt:secret
DIR /R file.txt
TYPE file.txt:secret
MKDIR kids
ECHO top-secret-information-going-here > kids:hidden
DIR /R
MORE < kids:hidden
Get-Content file.txt -Stream secret


#Insert a script into an ADS! (this one pings Google)
Write-Output "Nothing to see here!" > notes.txt
Add-Content -Path .\notes.txt -Value 'Dim oShell' -Stream 'cantseeme.vbs'
Add-Content -Path .\notes.txt -Value 'Set oShell = Wscript.CreateObject ("Wscript.Shell")' -Stream 'cantseeme.vbs'
Add-Content -Path .\notes.txt -Value 'oShell.run "cmd /k CD C:\Program Files & ping 8.8.8.8" ,1 , true ' -Stream 'cantseeme.vbs'
Get-Content .\notes.txt
Get-Content .\notes.txt -Stream cantseeme.vbs
wscript .\notes.txt:cantseeme.vbs
Certutil -hashfile notes.txt MD5
notepad notes.txt:cantseeme.vbs
# Add any lines of text to the end of the file that you like
notepad notes.txt:cantseeme.vbs
Certutil -hashfile notes.txt MD5

#endregion Alternate Data Streams