#!/bin/bash
if : ; then
# File:         boolean.sh
# Name:         Kevin Crotty
# Date:         25 Mar 2019
# Desc:         Show Boolean Logic usage when running commands
# Usage:        source boolean.sh

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White

# Example demonstraion of color usage
# echo -e "${BGreen} \# \n "
# echo -e "\n${BRed} ${NC}"
fi

reset

echo
echo -e "\n\n${BGreen}# Testing Command return Values${NC}"
echo
echo -e "${BRed}echo Something${NC}"
echo -e "Something${NC}"
echo -e "${BRed}echo \$?${NC}"
echo -e "0${NC}"
echo
echo -e "${BRed}cat adkfjhh${NC}"
echo -e "cat: adkfjhh: No such file or directory${NC}"
echo -e "${BRed}echo \$?${NC}"
echo -e "1${NC}"
echo
echo -e "${BRed}man hiert${NC}"
echo -e "No manual entry for hiert${NC}"
echo -e "${BRed}echo \$?${NC}"
echo -e "127${NC}"
echo -e "${BRed}echo \$?${NC}"
echo -e "0${NC}"
echo
echo -e "${BGreen}# Command Logic Examples${NC}"
echo
echo -e "${BRed}cd /tmp && ls -l && echo -e \"It works\"${NC}"
echo -e ".rw-------  dayman  dayman  0 B  Wed May 15 14:10:03 2019  config-err-fVOWS0"
echo -e "drwx------    root    root    -  Wed May 15 14:10:02 2019  snap.canonical-livepatch_ADhQs6"
echo -e "drwx------  dayman  dayman    -  Wed May 15 14:10:03 2019  ssh-1Q01rYRWXZZN"
echo
echo -e "It works${NC}"
echo
echo -e "${BRed}cd /tmp/fakedir && ls -l && echo -e \"It works\"${NC}"
echo -e "./boolean.sh: line 57: cd: /fakedir: No such file or directory${NC}"
echo
echo -e "${BRed}cd /tmp/fakedir || mkdir /tmp/fakedir && echo \"Directory Made!!\"${NC}"
echo -e "./boolean.sh: line 61: cd: /tmp/fakedir: No such file or directory${NC}"
echo -e "Directroy Made!!"
echo
echo -e "${BRed}pwd${NC}"
echo -e "/repo/public-old/modules/linux/v1/2_BashEnv${NC}"
echo
echo -e "${BRed}cd /tmp/fakedir || mkdir /tmp/fakedir${NC}"
echo -e "${BRed}pwd${NC}"
echo -e "/tmp/fakedir${NC}"
echo
echo -e "${BGreen}# Negate Selection${NC}"
echo
echo -e "${BRed}touch file1.txt file2.doc file3.pdf${NC}"
echo -e "${BRed}ls *.pdf${NC}"
echo -e "file3.pdf${NC}"
echo
echo -e "${BRed}ls !(*.pdf)${NC}"
echo -e "file1.txt  file2.doc${NC}\n\n\n"
