#!/bin/bash
if : ; then
# File:         conditionals.sh
# Name:         Kevin Crotty
# Date:         31 Mar 2019
# Desc:        	Conditionals in Bash
# Usage:        ./conditionals.sh

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White

function colorComment { echo -e "\n${BGreen}${1}${NC}"
}
function colorCommand { echo -e "${BRed}${1}${NC}"
}
fi

reset
colorComment "# String Comparisons (Single or Double equal signs both work)"
colorCommand "if test String1 == String2; then echo \"True\"; else echo \"False\"; fi"
echo -e "False"
colorCommand "\nif [ String1 == String1 ]; then echo \"True\"; else echo \"False\"; fi"
echo -e "True"
colorCommand "\nif [[ String1 == String2 ]]; then echo \"True\"; else echo \"False\"; fi"
echo -e "False"

colorComment "# Numeric Comparisons"
colorCommand "x=10"
colorCommand "if [ 4 -gt \$x ]; then echo \"True\"; else echo \"False\"; fi"
echo -e "False"
colorCommand "\nif (( 4 < \$x )); then echo \"True\"; else echo \"False\"; fi"
echo -e "True"

colorComment "# File Conditions"
colorCommand "if [ -e /etc/passwd ]; then echo \"File exists\"; else echo \"That's a problem\"; fi"
echo -e "File exists"
colorCommand "\nif [ ! -e /etc/passwd ]; then echo \"File exists\"; else echo \"That's a problem\"; fi"
echo  -e "That's a problem"

colorComment "# Combining Tests Old"
colorCommand "if [ yes == "yes" ] && [ 3 -gt 5 ]; then echo \"True\"; else echo \"False\"; fi"
echo  -e "False"

colorComment "# Combining Tests New"
colorCommand "if [[ yes == "no"  || 3 -lt 5 ]]; then echo \"True\"; else echo \"False\"; fi"
echo  -e "True\n\n"
