#!/bin/bash
if : ; then
# File:         sed.sh
# Name:         Kevin Crotty
# Date:         1 Apr 2019
# Desc:         Sed Basics
# Usage:        ./sed.sh

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export Blue='\e[0;34m'         # Blue
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White

: ' The two functions below colorize
    comments in green, and
    commands in red.'

function colorComment { echo -e "\n${BGreen}${1}${NC}"
}
function colorCommand { echo -e "${BRed}${1}${NC}"
}
fi
reset

# Make a temporary file with 16 lines
for i in {1..9}; do num=$(base64 /dev/urandom | head -c 10); echo "This is line $i with random pattern $num" >> lines.text; done
file=lines.text
var=$(cat $file)
echo -e "${BCyan}\n--Original Text--\n${Blue}$var${BCyan}\n--End Text--${NC}"

colorComment "# Basic Sed Substitution examples"
colorCommand "sed 's/line/sentence/' \$file ${BPurple}| head -n3"
sed 's/line/sentence/' $file | head -n3 && echo
colorCommand "sed 's/i/7/' \$file ${BPurple}| head -n3"
sed 's/i/7/' $file | head -n3 && echo
colorCommand "sed 's/i/7/g' \$file ${BPurple}| head -n3"
sed 's/i/7/g' $file | head -n3 && echo
colorCommand "sed '3 s/random/RANDOM/' \$file"
sed '3 s/random/RANDOM/' $file | head -n3 && echo
colorCommand "sed '/line 2/s/line/LINE/' \$file ${BPurple}| head -n3"
sed '/line 2/s/line/LINE/' $file | head -n3 && echo
colorCommand "echo \$PWD | sed 's:/://:'"
echo $PWD | sed 's:/://:'

rm *.text
echo && echo
