#!/bin/bash
if :
then

  # Set Colors for use in the script
  export NC='\e[0m'               # Text Reset
  export BBlack='\e[1;30m'        # Black
  export BRed='\e[1;31m'          # Red
  export BGreen='\e[1;32m'        # Green
  export Green='\e[0;32m'        # Green
  export BYellow='\e[1;33m'       # Yellow
  export BBlue='\e[1;34m'         # Blue
  export BPurple='\e[1;35m'       # Purple
  export BCyan='\e[1;36m'         # Cyan
  export BWhite='\e[1;37m'        # White

fi

reset

echo -e "${BBlue}#--Unnamed Pipes--"
echo -e "${BGreen}#  Unamed Pipes (|) are useful when all the processes are going to be run at the same time,${NC}"
echo -e "${BGreen}#+ and the STDOUT of one procces becomes the STDIN of the next.${NC}"
echo -e "${BRed}cat ${BPurple}\$FILENAME${BGreen} | grep \"${BPurple}\$PATTERN${BGreen}\" | awk '{print \$4}'${NC}\n"

echo -e "${BBlue}#--Named Pipes--"
echo -e "${BGreen}#  Named Pipes are better when seperate processes need to communicate at different times.${NC}"
echo -e "${BGreen}#+ The following script creates a named pipe that will continuosuly wait for input,${NC}"
echo -e "${BGreen}#+ then return that input in ALL CAPS"
echo -e "${BRed}cat > capitalize.sh << 'EOF'${NC}"
echo -e "mkfifo mypipe"
echo -e "PIPE=mypipe"
echo -e "    while :"
echo -e "    do"
echo -e "        if read lower <\$PIPE"
echo -e "        then"
echo -e "            if [[ \"\$lower\" == 'exit' ]]"
echo -e "            then"
echo -e "                break"
echo -e "            fi"
echo -e "            upper=\${lower^^}! ${Green}# Capitalizes all of the characters in the variable 'a' and saves it to 'line'${NC}"
echo -e "            echo \$upper"
echo -e "        fi"
echo -e "    done"
echo -e "echo \"Exited\""
echo -e "${BRed}EOF${NC}\n\n"

echo -e "${BGreen}# Set the script as executable and run the script in the background"
echo -e "${BRed}chmod 755 capitalize.sh && ./capitalize.sh &\n\n${NC}"

echo -e "${BGreen}# Send a string to the pipe to test"
echo -e "${BRed}echo hello > mypipe${NC}"
echo -e "HELLO!\n"

echo -e "${BBlue}#--First In, First Out Example--"
echo -e "${BGreen}# As soon as the data is generated and sent to the pipe, it is read by bzip2 and is compressed. Never actually writing 500GB to disk${NC}"
echo -e "${BRed}dd if=/dev/zero bs=100M count=5000 | bzip2 -c > totally.not.a.bomb.bz2 &${NC}"
echo -e "${BRed}ls -l${NC}"
echo -e "-rw-r--r-- 1 root root 1.5M Apr 21 20:59 totally.not.a.bomb.bz2\n\n"
