#!/bin/bash
if : ; then
# File:            file_perm.sh
# Name:            Kevin Crotty
# Date:            26 Mar 2019
# Desc:            Show's the differences in directory perms.
# Usage:          . file_perm.sh (as root)

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White

# Example demonstraion of color usage
# echo -e "${BGreen} \# \n "
# echo -e "\n${BRed} ${NC}"
fi

touch test
echo -e "\n${BRed}chmod 644 test${NC}"
chmod 644 test # Read/Write for Owner, Read for Group and Others
ls -l test
echo -e "\n${BRed}chmod 600 test${NC}"
chmod 600 test # Read/Write for Owner only
ls -l test
echo -e "\n${BRed}chmod 755 test${NC}"
chmod 755 test #  All perms for Owner, Read and Execute for Group and Others
ls -l test
echo -e "\n${BRed}chmod 700 test${NC}"
chmod 700 test # Read/Write/Execute for Owner only
ls -l test
echo -e "\n${BRed}chmod u=rw,go=r test${NC}"
chmod u=rw,go=r test # Same as 644
ls -l test
echo -e "\n${BRed}chmod ugo=,u+rwx,go+rx test${NC}"
chmod ugo=,u+rwx,go+rx test # Same as 755
ls -l test
echo -e "\n${BRed}chmod 4644 test${NC}"
chmod 4644 test # Sets only the suid bit
ls -l test
echo -e "\n${BRed}chmod 6755 test${NC}"
chmod 6755 test # Sets the suid and guid bit
ls -l test
echo -e "\n${BRed}chmod 1645 test${NC}"
chmod 1645 test # Sets the suid and guid bit
ls -l test
rm test
