#!/bin/bash
if : ; then
# File:         login.sh
# Name:         Kevin Crotty
# Date:         20 APR 2019
# Desc:         Show Different ways to run a command, and the differen effects of each
# Usage:        ./login.sh

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White

function colorComment { echo -e "\n${BGreen}${1}${NC}"
}
function colorCommand { echo -e "${BRed}${1}${NC}"
}
fi

reset

colorComment "# Make Test Script"
colorCommand "echo \"shopt login_shell\" > test.sh"
colorCommand "echo \"\$-\" >> test.sh"

colorComment "# Run script"
echo -e "${BRed}root# ./test.sh${NC}"
echo -e "login_shell off${NC}"
echo -e "hB${NC}"

colorComment "# Source script"
echo -e "${BRed}root# source test.sh${NC}"
echo -e "login_shell on${NC}"
echo -e "himBHs${NC}"

colorComment "# Run with bash in login mode and non-interactivly"
echo -e "${BRed}root# bash --login test.sh${NC}"
echo -e "You Ran ${BPurple}/etc/profile${NC}"
echo -e "You Ran ${BPurple}/root/.profile${NC}"
echo -e "You Ran ${BPurple}/root/.bashrc${NC}"
echo -e "login_shell on${NC}"
echo -e "hB${NC}"

colorComment "# Run with bash in non-login mode and interactivly"
echo -e "${BRed}root# bash -i test.sh${NC}"
echo -e "You Ran ${BPurple}/etc/bash.bashrc${NC}"
echo -e "You Ran ${BPurple}/root/.bashrc${NC}"
echo -e "login_shell off${NC}"
echo -e "himB${NC}"

colorComment "# Run with bash in login mode and interactivly"
echo -e "${BRed}root# bash --login -i test.sh${NC}"
echo -e "You Ran ${BPurple}/etc/profile${NC}"
echo -e "You Ran ${BPurple}/etc/bash.bashrc${NC}"
echo -e "You Ran ${BPurple}/root/.profile${NC}"
echo -e "You Ran ${BPurple}/root/.bashrc${NC}"
echo -e "login_shell on${NC}"
echo -e "himB\n\n${NC}"
