#!/bin/bash
if : ; then
# File:         logs.sh
# Name:         Kevin Crotty
# Date:         4 Apr 2019
# Desc:         Illustrate different log enumeration commands
# Usage:        ./logs.sh

# Set Colors for use in the script
export NC='\e[0m'               # Text Reset
export BBlack='\e[1;30m'        # Black
export BRed='\e[1;31m'          # Red
export BGreen='\e[1;32m'        # Green
export BYellow='\e[1;33m'       # Yellow
export BBlue='\e[1;34m'         # Blue
export BPurple='\e[1;35m'       # Purple
export BCyan='\e[1;36m'         # Cyan
export BWhite='\e[1;37m'        # White

function colorComment { echo -e "\n${BGreen}${1}${NC}"
}
function colorCommand { echo -e "${BRed}${1}${NC}"
}
fi

clear
colorComment " # Shows the RULES portion of the /etc/rsyslog.conf file\n"
echo -e " ${BCyan}student \$ ${BRed}tail -n40 /etc/rsyslog.conf\n${NC}"

echo -e " ${BPurple}<--Output trimmed-->\n${NC}"

echo -e " auth,authpriv.*                        ${BBlue}/var/log/auth.log${NC}"
echo -e " *.*;auth,authpriv.no                   ${BBlue}-/var/log/syslog${NC}"
echo -e " mail.*                                 ${BBlue}-/var/log/mail.log${NC}\n"

echo -e " *.info                                 ${BBlue}@@10.10.10.1:514${NC}"
echo -e " *.=info;*.=notice;*.=warn;\\"
echo -e " 	auth,authpriv.none;\\"
echo -e " 	cron,daemon.none;\\"
echo -e " 	mail,news.none                 ${BBlue}-/var/log/messages${NC}\n"

echo -e " ${BPurple}<--Output trimmed-->\n\n\n${NC}"
